#ifndef HIMWNH
#define HIMWNH 1

#ifdef AUTODOC

Include File: wn.h

Description: 

Include file for HIM Window Manager module.

#endif
/*
 *
 *   Copyright 1988  Allsoft (tm)
 *   100 Calle Playa Del Sol NE
 *   Albuquerque, NM  87109
 *
 *   ALL RIGHTS RESERVED.
 *
 *   Unauthorized distribution, adaptation or use may be 
 *   subject to civil and criminal penalties.
 *
 */
/********** Filled by Polytron Version Control System **********

$Author:   james borders  $

$Date:   07 May 1988 16:19:40  $

$Revision:   1.0  $

$Log:   D:/C/FMLIB/WN/VCS/WN.H  $
   
      Rev 1.0   07 May 1988 16:19:40   james borders
   Initial revision.

****************************************************************/

/* Window Manager Constants */

/* Colors */

#define WNBLACK         0
#define WNBLUE          1
#define WNGREEN         2
#define WNCYAN          3
#define WNRED           4
#define WNMAGENTA       5
#define WNBROWN         6
#define WNGRAY          7
#define WNDGRAY         8
#define WNLBLUE         9
#define WNLGREEN        10
#define WNLCYAN         11
#define WNLRED          12
#define WNLMAGENTA      13
#define WNYELLOW        14
#define WNWHITE         15

#define WNBLINK         128 /* OR with attribute to cause blinking */

/* mono highlight attributes */

#define WNNORMAL        0x07
#define WNREVERSE       0x70
#define WNUNDERLINE     0x47

/* Cursor types */

#define WNNOCURSOR      0
#define WNUNDCURSOR     1
#define WNSOLCURSOR     2

/* wnscroll directions */

#define WUP             0
#define WDOWN           1

/* error constants */

#define WNOK         0          /* no error */
#define WNMAERROR   -1          /* memory allocation error */
#define WNFWERROR   -2          /* file write error */
#define WNBADWIN    -3          /* bad window number */
#define WNFRERROR   -4          /* file read error */
#define WNWTBERROR  -5          /* window dimension(s) to big for screen */
#define WNBVMERROR  -6          /* unsupported video mode seen in wninit() */
#define WNPORERROR  -7          /* parameter other than wnum out of range */
#define WNDTBERROR  -8          /* data to big for len in wninput() */

/* Use this with wneditstring() if no action routine wanted */

#define WNINULL      (int (*)())NULL
#define WNACTIONNULL (int (*)())NULL


/* data input types for wninput function */

#define WNCHAR          0x0001
#define WNCHARSTR       0x0002
#define WNINT           0x0003
#define WNUINT          0x0004
#define WNLINT          0x0005
#define WNULINT         0x0006
#define WNFLOAT         0x0007
#define WNDOUBLE        0x0008

/* OR these with the above to control how display and entry is handled */

#define WNDPTRDISPLAY     0x0010
#define WNDISPLAYONLY     0x0020
#define WNWIPE            0x0040
#define WNCRCHOP          0x0080
#define WNNOECHO          0x0100
#define WNNOTRIM          0x0200

/* wninput return values */

#define WNCR            1
#define WNESC           2

/* this can also be passed to action routine as well as 2 above */

#define WNBADCHAR       3

/* don't touch these */

#define WNDTYPEMASK     0x000f

/* function declarations */

/*global*/  int wnscwnum(int);
/*global*/  int wnsize(int ,int ,int );
/*global*/  int wnswcolor(int ,int ,int );
/*global*/  int wnswbcolor(int ,int ,int );
/*global*/  int wnswtbc(int ,int ,int );
/*global*/  int wnswcmode(int ,int );
/*global*/  int wnswwwrap(int ,int );
/*global*/  int wnswscroll(int ,int );
/*global*/  int wnswbchars(int ,int ,int ,int ,int ,int ,int ,int ,int ,int ,int ,int );
/*global*/  void wnscparms(int, int, int,int, int, int, int, int, int, int, int, int, int, int); 
/*global*/  int wngcwnum(void);
/*global*/  int wngwrow(int );
/*global*/  int wngwcol(int );
/*global*/  int wngwwidth(int );
/*global*/  int wngwheight(int );
/*global*/  int wngwbc(int );
/*global*/  int wngwfc(int );
/*global*/  int wngwbbc(int );
/*global*/  int wngwbfc(int );
/*global*/  int wngwtbc(int );
/*global*/  int wngwtfc(int );
/*global*/  int wngwcrow(int );
/*global*/  int wngwccol(int );
/*global*/  int wngwcmode(int );
/*global*/  int wngwwwrap(int );
/*global*/  int wngwscroll(int );
/*global*/  int wngwbchars(int ,char *,char *,char *,char *,char *,char *,char *,char *,char *,char *,char *);
/*global*/  void wngcparms(int *, int *, int *, int *, int *, int *, int *, int *, int *, int *, int *, int *, int *, int *); 
/*global*/  int wngsrows(void);
/*global*/  int wngscols(void);
/*global*/  int wninit(int ,int ,char *,unsigned int ,char *(*)(),void (*)());
/*global*/  int wncreate(int ,int ,int ,int ,int ,int ,int ,int );
/*global*/  int wndestroy(int );
/*global*/  int wnfill(int ,int );
/*global*/  int wncls(int );
/*global*/  int wrestore(void);
/*global*/  int wsaverestoretofile(int ,int ,int ,int ,long ,int );
/*global*/  void wregensave(int ,int ,int ,int ,unsigned int far *);
/*global*/  void wregenrestore(int ,int ,int ,int ,unsigned int far *);
/*global*/  int writeread(int ,char *,int ,int );
/*global*/  int wnbldwatt(int );
/*global*/  int wnbldnatt(int ,int ,int );
/*global*/  int wnbldhatt(int ,int ,int );
/*global*/  int wnghmatt(void);
/*global*/  int wnshmatt(int );
/*global*/  void wdrawborder(void);
/*global*/  void wdrawside(int );
/*global*/  int wnumcheck(int );
/*global*/  int vpgvmode(void);
/*global*/  void vpsvmode(int );
/*global*/  void vpgcpos(int *,int *);
/*global*/  void vpscpos(int ,int );
/*global*/  int vpgtcols(void);
/*global*/  void vpgcstyle(int *,int *);
/*global*/  void vpscstyle(int ,int );
/*global*/  void vpscmode(int );
/*global*/  int wnmove(int ,int ,int );
/*global*/  int wnmovechar(int ,int ,int );
/*global*/  int wnmoves(int ,int ,int ,int );
/*global*/  int wnscroll(int ,int ,int ,int );
/*global*/  int wndline(int );
/*global*/  int wndeol(int );
/*global*/  int wndeow(int );
/*global*/  int wnbs(int );
/*global*/  int wninsline(int );
/*global*/  int wninschar(int );
/*global*/  int wnputncolor(int ,int ,int ,int );
/*global*/  int wnlputncolor(int ,int ,int ,int ,int ,int );
/*global*/  int wnputhcolor(int ,int ,int ,int );
/*global*/  int wnlputhcolor(int ,int ,int ,int ,int ,int );
/*global*/  int wtoright(void);
/*global*/  int wtobottom(void);
/*global*/  int wnttitle(int ,char *);
/*global*/  int wnbtitle(int ,char *);
/*global*/  int wnltitle(int ,char *);
/*global*/  int wnrtitle(int ,char *);

#endif /* HIMWNH */
