/*******************************************************************************
+
+  LEDA  2.1.1                                                 11-15-1991
+
+
+  edge_set.h
+
+
+  Copyright (c) 1991  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/


#ifndef EDGE_SET_H
#define EDGE_SET_H

#include <LEDA/graph.h>



//------------------------------------------------------------------------------
// edge_set  
//------------------------------------------------------------------------------

class edge_set {
graph* g;
list(edge) L;
graph_array(edge) A;
public:
void insert(edge x)  { if (A.inf(x) == nil) A.entry(x) = Ent(L.append(x)); }
void del(edge x)     { if (A.inf(x) != nil) 
                        { L.del(list_item(A.inf(x))); A.entry(x) = nil;} 
                      }
bool member(edge x)      { return (A.inf(x) != nil) ? true:false; }
edge choose()  const     { return L.head(); }
int  size()    const     { return L.length(); }
bool empty()   const     { return L.empty(); }
void clear()             { L.clear(); A.init(*g,nil); }
edge_set(const graph& G) { g = (graph*)&G; A.init(G,nil);}
~edge_set()              { L.clear(); A.clear(); }
};


#endif
