/*******************************************************************************
+
+  LEDA  2.1.1                                                 11-15-1991
+
+
+  _topsort.c
+
+
+  Copyright (c) 1991  by  Max-Planck-Institut fuer Informatik
+  Im Stadtwald, 6600 Saarbruecken, FRG     
+  All rights reserved.
+ 
*******************************************************************************/



/*******************************************************************************
*                                                                              *
*  TOPSORT (topological sorting)                                               *
*                                                                              *
*******************************************************************************/



#include <LEDA/graph_alg.h>


bool TOPSORT(const graph& G, node_array(int)& ord)
{ 
  node_array(int) INDEG(G);
  list(node) ZEROINDEG;

  int count=0;
  node v,w;

  forall_nodes(v,G) if ((INDEG[v]=indeg(v))==0) ZEROINDEG.append(v); 

  while (!ZEROINDEG.empty())
   { v = ZEROINDEG.pop();
     ord[v] = ++count;
     forall_adj_nodes(w,v) 
        if (--INDEG[w]==0) ZEROINDEG.append(w);
    }
  
  
  if (count==G.number_of_nodes()) 
     return(true);
  else 
     return(false);
}
     



// TOPSORT1 rearrange nodes and edges 


static node_array(int) ord;

static cmp_node_ord(node& v, node& w)   
{ return ord[v] - ord[w]; }

static cmp_edge_ord(edge& e1, edge& e2) 
{ return cmp_node_ord(target(e1),target(e2)); }

bool TOPSORT1(graph& G)
{ 
  ord.init(G);

  if (TOPSORT(G,ord))
   { G.sort_nodes(cmp_node_ord);
     G.sort_edges(cmp_edge_ord);
     return true;
    }

  else return false;
  
}
     

